

<!DOCTYPE html>

<html lang="ja">
  <head>
    <meta charset="utf-8" />
    <meta name="viewport" content="width=device-width, initial-scale=1.0" />
    <title>7.15.17. query &#8212; Groonga v10.1.1-31-g1e46ba6ドキュメント</title>
    <link rel="stylesheet" href="../../_static/groonga.css" type="text/css" />
    <link rel="stylesheet" href="../../_static/pygments.css" type="text/css" />
    
    <script id="documentation_options" data-url_root="../../" src="../../_static/documentation_options.js"></script>
    <script src="../../_static/jquery.js"></script>
    <script src="../../_static/underscore.js"></script>
    <script src="../../_static/doctools.js"></script>
    <script src="../../_static/language_data.js"></script>
    <script src="../../_static/translations.js"></script>
    
    <link rel="shortcut icon" href="../../_static/favicon.ico"/>
    <link rel="index" title="索引" href="../../genindex.html" />
    <link rel="search" title="検索" href="../../search.html" />
    <link rel="next" title="7.15.18. rand" href="rand.html" />
    <link rel="prev" title="7.15.16. prefix_rk_search" href="prefix_rk_search.html" /> 
  </head><body>
<div class="header">
  <h1 class="title">
    <a id="top-link" href="../../index.html">
      <span class="project">groonga</span>
      <span class="separator">-</span>
      <span class="description">オープンソースのカラムストア機能付き全文検索エンジン</span>
    </a>
  </h1>

  <div class="other-language-links">
    <ul>
      <li><a href="../../../../en/html/reference/functions/query.html">English</a></li>
    </ul>
  </div>
</div>
  

    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             accesskey="I">索引</a></li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             accesskey="N">次へ</a> |</li>
        <li class="right" >
          <a href="prefix_rk_search.html" title="7.15.16. prefix_rk_search"
             accesskey="P">前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" accesskey="U"><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.17. </span><code class="docutils literal notranslate"><span class="pre">query</span></code></a></li> 
      </ul>
    </div>  

    <div class="document">
      <div class="documentwrapper">
        <div class="bodywrapper">
          <div class="body" role="main">
            
  <div class="section" id="query">
<h1><span class="section-number">7.15.17. </span><code class="docutils literal notranslate"><span class="pre">query</span></code><a class="headerlink" href="#query" title="このヘッドラインへのパーマリンク">¶</a></h1>
<div class="section" id="summary">
<h2><span class="section-number">7.15.17.1. </span>概要<a class="headerlink" href="#summary" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> は、<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> の <code class="docutils literal notranslate"><span class="pre">--match_columns</span></code> と <code class="docutils literal notranslate"><span class="pre">--query</span></code> 引数の機能を関数として提供します。<a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> の <code class="docutils literal notranslate"><span class="pre">--filter</span></code> 引数で複数の <code class="docutils literal notranslate"><span class="pre">query</span></code> 関数を指定することができます。</p>
<p>そのような柔軟性があるので、 複数の <code class="docutils literal notranslate"><span class="pre">query</span></code> 関数を組合せることで全文検索の振舞いを制御することができます。</p>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> は <a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a> コマンドの <code class="docutils literal notranslate"><span class="pre">--filter</span></code> 内でのみ指定できます。</p>
</div>
<div class="section" id="syntax">
<h2><span class="section-number">7.15.17.2. </span>構文<a class="headerlink" href="#syntax" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> は2つの引数が必要です。 <code class="docutils literal notranslate"><span class="pre">match_columns</span></code> と <code class="docutils literal notranslate"><span class="pre">query_string</span></code> です。</p>
<p>引数の <code class="docutils literal notranslate"><span class="pre">query_expander</span></code> や <code class="docutils literal notranslate"><span class="pre">substitution_table</span></code> 、 <code class="docutils literal notranslate"><span class="pre">options</span></code> は省略可能です。</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>query(match_columns, query_string)
query(match_columns, query_string, query_expander)
query(match_columns, query_string, substitution_table)
query(match_columns, query_string, options)
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">options</span></code> には以下のキーを指定します。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>{
  &quot;expander&quot;: query_expander,
  &quot;default_mode&quot;: default_mode,
  &quot;flags&quot;: flags
}
</pre></div>
</div>
</div>
<div class="section" id="usage">
<h2><span class="section-number">7.15.17.3. </span>使い方<a class="headerlink" href="#usage" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p>使い方を示すために使うスキーマ定義とサンプルデータは以下の通りです。</p>
<p>サンプルスキーマ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>table_create Documents TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Documents content COLUMN_SCALAR Text
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Terms TABLE_PAT_KEY ShortText --default_tokenizer TokenBigram  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Terms documents_content_index COLUMN_INDEX|WITH_POSITION Documents content
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Users TABLE_NO_KEY
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Users name COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Users memo COLUMN_SCALAR ShortText
# [[0, 1337566253.89858, 0.000355720520019531], true]
table_create Lexicon TABLE_HASH_KEY ShortText \
  --default_tokenizer TokenBigramSplitSymbolAlphaDigit \
  --normalizer NormalizerAuto
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon users_name COLUMN_INDEX|WITH_POSITION Users name
# [[0, 1337566253.89858, 0.000355720520019531], true]
column_create Lexicon users_memo COLUMN_INDEX|WITH_POSITION Users memo
# [[0, 1337566253.89858, 0.000355720520019531], true]
</pre></div>
</div>
<p>サンプルデータ:</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>load --table Users
[
{&quot;name&quot;: &quot;Alice&quot;, &quot;memo&quot;: &quot;groonga user&quot;},
{&quot;name&quot;: &quot;Alisa&quot;, &quot;memo&quot;: &quot;mroonga user&quot;},
{&quot;name&quot;: &quot;Bob&quot;,   &quot;memo&quot;: &quot;rroonga user&quot;},
{&quot;name&quot;: &quot;Tom&quot;,   &quot;memo&quot;: &quot;nroonga user&quot;},
{&quot;name&quot;: &quot;Tobby&quot;, &quot;memo&quot;: &quot;groonga and mroonga user. mroonga is ...&quot;},
]
# [[0, 1337566253.89858, 0.000355720520019531], 5]
</pre></div>
</div>
<p><code class="docutils literal notranslate"><span class="pre">--match_columns</span></code> と <code class="docutils literal notranslate"><span class="pre">--query</span></code> 引数を使わずにキーワード'alice'を <code class="docutils literal notranslate"><span class="pre">query</span></code> 関数を使って検索する簡単な使用例です。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Users --output_columns name,_score --filter &#39;query(&quot;name * 10&quot;, &quot;alice&quot;)&#39;
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         1
#       ],
#       [
#         [
#           &quot;name&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;_score&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Alice&quot;,
#         10
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>上記のクエリを実行する際、'alice'というキーワードには重みづけとして値 <code class="docutils literal notranslate"><span class="pre">10</span></code> を設定します。</p>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> あり/なしで対照的な例がこちらです。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Users --output_columns name,memo,_score --match_columns &quot;memo * 10&quot; --query &quot;memo:@groonga OR memo:@mroonga OR memo:@user&quot; --sort_keys -_score
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;name&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;memo&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;_score&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Tobby&quot;,
#         &quot;groonga and mroonga user. mroonga is ...&quot;,
#         4
#       ],
#       [
#         &quot;Alice&quot;,
#         &quot;groonga user&quot;,
#         2
#       ],
#       [
#         &quot;Alisa&quot;,
#         &quot;mroonga user&quot;,
#         2
#       ],
#       [
#         &quot;Bob&quot;,
#         &quot;rroonga user&quot;,
#         1
#       ],
#       [
#         &quot;Tom&quot;,
#         &quot;nroonga user&quot;,
#         1
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>この場合、 <code class="docutils literal notranslate"><span class="pre">groonga</span></code> と <code class="docutils literal notranslate"><span class="pre">mroonga</span></code> と <code class="docutils literal notranslate"><span class="pre">user</span></code> というキーワードは同じ重みづけがされています。この方法ではキーワードごとに異なる重みづけを行うことはできません。</p>
<p>実行例:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>select Users --output_columns name,memo,_score --filter &#39;query(&quot;memo * 10&quot;, &quot;groonga&quot;) || query(&quot;memo * 20&quot;, &quot;mroonga&quot;) || query(&quot;memo * 1&quot;, &quot;user&quot;)&#39; --sort_keys -_score
# [
#   [
#     0,
#     1337566253.89858,
#     0.000355720520019531
#   ],
#   [
#     [
#       [
#         5
#       ],
#       [
#         [
#           &quot;name&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;memo&quot;,
#           &quot;ShortText&quot;
#         ],
#         [
#           &quot;_score&quot;,
#           &quot;Int32&quot;
#         ]
#       ],
#       [
#         &quot;Tobby&quot;,
#         &quot;groonga and mroonga user. mroonga is ...&quot;,
#         51
#       ],
#       [
#         &quot;Alisa&quot;,
#         &quot;mroonga user&quot;,
#         21
#       ],
#       [
#         &quot;Alice&quot;,
#         &quot;groonga user&quot;,
#         11
#       ],
#       [
#         &quot;Tom&quot;,
#         &quot;nroonga user&quot;,
#         1
#       ],
#       [
#         &quot;Bob&quot;,
#         &quot;rroonga user&quot;,
#         1
#       ]
#     ]
#   ]
# ]
</pre></div>
</div>
<p>一方、複数の <code class="docutils literal notranslate"><span class="pre">query</span></code> を指定することで、 <code class="docutils literal notranslate"><span class="pre">groonga</span></code> と <code class="docutils literal notranslate"><span class="pre">mroonga</span></code> と <code class="docutils literal notranslate"><span class="pre">user</span></code> それぞれのキーワードに対し異なる重みづけを行えます。</p>
<p>結果として、意図した様に異なる重みづけを行いつつ全文検索の振舞いを制御することができます。</p>
</div>
<div class="section" id="parameters">
<h2><span class="section-number">7.15.17.4. </span>引数<a class="headerlink" href="#parameters" title="このヘッドラインへのパーマリンク">¶</a></h2>
<div class="section" id="required-parameters">
<h3><span class="section-number">7.15.17.4.1. </span>必須引数<a class="headerlink" href="#required-parameters" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>必須引数は二つあります。 <code class="docutils literal notranslate"><span class="pre">match_columns</span></code> と <code class="docutils literal notranslate"><span class="pre">query_string</span></code> です。</p>
<div class="section" id="match-columns">
<h4><span class="section-number">7.15.17.4.1.1. </span><code class="docutils literal notranslate"><span class="pre">match_columns</span></code><a class="headerlink" href="#match-columns" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p><code class="docutils literal notranslate"><span class="pre">query_string</span></code> パラメーターの値で全文検索するときのデフォルトの検索対象カラムを指定します。このパラメーターは <code class="docutils literal notranslate"><span class="pre">select</span></code> の <a class="reference internal" href="../commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a> パラメーターと同じ役割です。</p>
</div>
<div class="section" id="query-string">
<h4><span class="section-number">7.15.17.4.1.2. </span><code class="docutils literal notranslate"><span class="pre">query_string</span></code><a class="headerlink" href="#query-string" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p><a class="reference internal" href="../grn_expr/query_syntax.html"><span class="doc">クエリー構文</span></a> で検索条件を指定します。このパラメーターは <code class="docutils literal notranslate"><span class="pre">select</span></code> コマンドの <code class="docutils literal notranslate"><span class="pre">query</span></code> パラメーターと同じ役割です。</p>
<p><code class="docutils literal notranslate"><span class="pre">select</span></code> コマンドの <code class="docutils literal notranslate"><span class="pre">query</span></code> については <a class="reference internal" href="../commands/select.html#select-match-columns"><span class="std std-ref">match_columns</span></a> を参照してください。</p>
</div>
</div>
<div class="section" id="optional-parameter">
<h3><span class="section-number">7.15.17.4.2. </span>省略可能引数<a class="headerlink" href="#optional-parameter" title="このヘッドラインへのパーマリンク">¶</a></h3>
<p>いくつか省略可能な引数があります。</p>
<div class="section" id="query-expander">
<h4><span class="section-number">7.15.17.4.2.1. </span><code class="docutils literal notranslate"><span class="pre">query_expander</span></code><a class="headerlink" href="#query-expander" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>クエリ展開に使うプラグイン名を指定します。</p>
<p><a class="reference internal" href="../query_expanders/tsv.html"><span class="doc">QueryExpanderTSV</span></a> は公式リリースに含まれているプラグインの1つです。</p>
<p>詳細については <a class="reference internal" href="../query_expanders/tsv.html"><span class="doc">QueryExpanderTSV</span></a> を参照してください。</p>
</div>
<div class="section" id="substitution-table">
<h4><span class="section-number">7.15.17.4.2.2. </span><code class="docutils literal notranslate"><span class="pre">置換テーブル</span></code><a class="headerlink" href="#substitution-table" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>置換テーブルとカラム名を <code class="docutils literal notranslate"><span class="pre">${TABLE}.${COLUMN}</span></code> という書式でクエリ展開のために指定します。</p>
<p>詳細は <a class="reference internal" href="../commands/select.html#select-query-expander"><span class="std std-ref">query_expander</span></a> を見てください。</p>
</div>
<div class="section" id="default-mode">
<span id="query-default-mode"></span><h4><span class="section-number">7.15.17.4.2.3. </span><code class="docutils literal notranslate"><span class="pre">default_mode</span></code><a class="headerlink" href="#default-mode" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>デフォルトの検索モードを指定します。検索モードは <code class="docutils literal notranslate"><span class="pre">column:&#64;keyword</span></code> というような構文でカスタマイズできます。デフォルトの検索モードは <code class="docutils literal notranslate"><span class="pre">column:&#64;keyword</span></code> ではなく単に <code class="docutils literal notranslate"><span class="pre">keyword</span></code> と指定したときに使われます。構文の詳細は <a class="reference internal" href="../grn_expr/query_syntax.html"><span class="doc">クエリー構文</span></a> を見てください。</p>
<p>以下は利用可能なモードです。デフォルトは <code class="docutils literal notranslate"><span class="pre">&quot;MATCH&quot;</span></code> モードです。このモードでは全文検索をします。</p>
<table class="docutils align-default">
<colgroup>
<col style="width: 33%" />
<col style="width: 33%" />
<col style="width: 33%" />
</colgroup>
<thead>
<tr class="row-odd"><th class="head"><p>モード</p></th>
<th class="head"><p>別名</p></th>
<th class="head"><p>説明</p></th>
</tr>
</thead>
<tbody>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;EQUAL&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;==&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-equal-condition"><span class="std std-ref">等価条件</span></a> を使います。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;NOT_EQUAL&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;!=&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-not-equal-condition"><span class="std std-ref">不等価条件</span></a> を使います。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;LESS&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;&lt;&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-less-than-condition"><span class="std std-ref">小なり条件</span></a> を使います。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;GREATER&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;&gt;&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-greater-than-condition"><span class="std std-ref">大なり条件</span></a> を使います。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;LESS_EQUAL&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;&lt;=&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-less-than-or-equal-condition"><span class="std std-ref">以下条件</span></a> を使います。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;GREATER_EQUAL&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;&gt;=&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-greater-than-or-equal-condition"><span class="std std-ref">以上条件</span></a> を使います。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;MATCH&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;&#64;&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-full-text-search-condition"><span class="std std-ref">全文検索条件</span></a> を使います。</p>
<p>これがデフォルトです。</p>
</td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;NEAR&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;*N&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-near-search-condition"><span class="std std-ref">近傍検索条件</span></a> を使います。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;SIMILAR&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;*S&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-similar-search-condition"><span class="std std-ref">類似文書検索条件</span></a> を使います。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;PREFIX&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;^&quot;</span></code>, <code class="docutils literal notranslate"><span class="pre">&quot;&#64;^&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-prefix-search-condition"><span class="std std-ref">前方一致検索条件</span></a> を使います。</p></td>
</tr>
<tr class="row-even"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;SUFFIX&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;$&quot;</span></code>, <code class="docutils literal notranslate"><span class="pre">&quot;&#64;$&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-suffix-search-condition"><span class="std std-ref">後方一致検索条件</span></a> を使います。</p></td>
</tr>
<tr class="row-odd"><td><p><code class="docutils literal notranslate"><span class="pre">&quot;REGEXP&quot;</span></code></p></td>
<td><p><code class="docutils literal notranslate"><span class="pre">&quot;~&quot;</span></code>, <code class="docutils literal notranslate"><span class="pre">&quot;&#64;~&quot;</span></code></p></td>
<td><p>デフォルトのモードとして <a class="reference internal" href="../grn_expr/query_syntax.html#query-syntax-regular-expression-condition"><span class="std std-ref">正規表現条件</span></a> を使います。</p></td>
</tr>
</tbody>
</table>
</div>
<div class="section" id="flags">
<h4><span class="section-number">7.15.17.4.2.4. </span><code class="docutils literal notranslate"><span class="pre">flags</span></code><a class="headerlink" href="#flags" title="このヘッドラインへのパーマリンク">¶</a></h4>
<p>クエリーのパース方法をカスタマイズするフラグを指定します。</p>
<p>1つ以上のフラグを指定できます。複数のフラグを指定する場合は <code class="docutils literal notranslate"><span class="pre">|</span></code> で区切ります。以下が複数のフラグを指定する例です。:</p>
<div class="highlight-none notranslate"><div class="highlight"><pre><span></span>query(&quot;title * 10 || content&quot;,
      &quot;keyword&quot;,
      {&quot;flags&quot;: &quot;ALLOW_COLUMN|ALLOW_LEADING_NOT&quot;})
</pre></div>
</div>
<p>詳細は <a class="reference internal" href="../commands/select.html#select-query-flags"><span class="std std-ref">query_flags</span></a> を見てください。</p>
</div>
</div>
</div>
<div class="section" id="return-value">
<h2><span class="section-number">7.15.17.5. </span>戻り値<a class="headerlink" href="#return-value" title="このヘッドラインへのパーマリンク">¶</a></h2>
<p><code class="docutils literal notranslate"><span class="pre">query</span></code> は1つでもレコードがマッチしたかどうかを返します。もし、1つ以上のレコードがマッチしたら <code class="docutils literal notranslate"><span class="pre">true</span></code> を返します。1つもマッチしなかったら <code class="docutils literal notranslate"><span class="pre">false</span></code> を返します。</p>
</div>
<div class="section" id="see-also">
<h2><span class="section-number">7.15.17.6. </span>参考<a class="headerlink" href="#see-also" title="このヘッドラインへのパーマリンク">¶</a></h2>
<ul class="simple">
<li><p><a class="reference internal" href="../commands/select.html"><span class="doc">select</span></a></p></li>
</ul>
</div>
</div>


            <div class="clearer"></div>
          </div>
        </div>
      </div>
      <div class="sphinxsidebar" role="navigation" aria-label="main navigation">
        <div class="sphinxsidebarwrapper">
  <h3><a href="../../index.html">目次</a></h3>
  <ul>
<li><a class="reference internal" href="#">7.15.17. <code class="docutils literal notranslate"><span class="pre">query</span></code></a><ul>
<li><a class="reference internal" href="#summary">7.15.17.1. 概要</a></li>
<li><a class="reference internal" href="#syntax">7.15.17.2. 構文</a></li>
<li><a class="reference internal" href="#usage">7.15.17.3. 使い方</a></li>
<li><a class="reference internal" href="#parameters">7.15.17.4. 引数</a><ul>
<li><a class="reference internal" href="#required-parameters">7.15.17.4.1. 必須引数</a><ul>
<li><a class="reference internal" href="#match-columns">7.15.17.4.1.1. <code class="docutils literal notranslate"><span class="pre">match_columns</span></code></a></li>
<li><a class="reference internal" href="#query-string">7.15.17.4.1.2. <code class="docutils literal notranslate"><span class="pre">query_string</span></code></a></li>
</ul>
</li>
<li><a class="reference internal" href="#optional-parameter">7.15.17.4.2. 省略可能引数</a><ul>
<li><a class="reference internal" href="#query-expander">7.15.17.4.2.1. <code class="docutils literal notranslate"><span class="pre">query_expander</span></code></a></li>
<li><a class="reference internal" href="#substitution-table">7.15.17.4.2.2. <code class="docutils literal notranslate"><span class="pre">置換テーブル</span></code></a></li>
<li><a class="reference internal" href="#default-mode">7.15.17.4.2.3. <code class="docutils literal notranslate"><span class="pre">default_mode</span></code></a></li>
<li><a class="reference internal" href="#flags">7.15.17.4.2.4. <code class="docutils literal notranslate"><span class="pre">flags</span></code></a></li>
</ul>
</li>
</ul>
</li>
<li><a class="reference internal" href="#return-value">7.15.17.5. 戻り値</a></li>
<li><a class="reference internal" href="#see-also">7.15.17.6. 参考</a></li>
</ul>
</li>
</ul>

  <h4>前のトピックへ</h4>
  <p class="topless"><a href="prefix_rk_search.html"
                        title="前の章へ"><span class="section-number">7.15.16. </span><code class="docutils literal notranslate"><span class="pre">prefix_rk_search</span></code></a></p>
  <h4>次のトピックへ</h4>
  <p class="topless"><a href="rand.html"
                        title="次の章へ"><span class="section-number">7.15.18. </span>rand</a></p>
<div id="searchbox" style="display: none" role="search">
  <h3 id="searchlabel">クイック検索</h3>
    <div class="searchformwrapper">
    <form class="search" action="../../search.html" method="get">
      <input type="text" name="q" aria-labelledby="searchlabel" />
      <input type="submit" value="検索" />
    </form>
    </div>
</div>
<script>$('#searchbox').show(0);</script>
        </div>
      </div>
      <div class="clearer"></div>
    </div>
    <div class="related" role="navigation" aria-label="related navigation">
      <h3>ナビゲーション</h3>
      <ul>
        <li class="right" style="margin-right: 10px">
          <a href="../../genindex.html" title="総合索引"
             >索引</a></li>
        <li class="right" >
          <a href="rand.html" title="7.15.18. rand"
             >次へ</a> |</li>
        <li class="right" >
          <a href="prefix_rk_search.html" title="7.15.16. prefix_rk_search"
             >前へ</a> |</li>
        <li class="nav-item nav-item-0"><a href="../../index.html">Groonga v10.1.1-31-g1e46ba6ドキュメント</a> &#187;</li>
          <li class="nav-item nav-item-1"><a href="../../reference.html" ><span class="section-number">7. </span>リファレンスマニュアル</a> &#187;</li>
          <li class="nav-item nav-item-2"><a href="../function.html" ><span class="section-number">7.15. </span>関数</a> &#187;</li>
        <li class="nav-item nav-item-this"><a href=""><span class="section-number">7.15.17. </span><code class="docutils literal notranslate"><span class="pre">query</span></code></a></li> 
      </ul>
    </div>
    <div class="footer" role="contentinfo">
        &#169; Copyright 2009-2021, Brazil, Inc.
    </div>
  </body>
</html>